Package org.mariadb.jdbc

## Class MariaDbStatement

- java.lang.Object
- - org.mariadb.jdbc.MariaDbStatement

All Implemented Interfaces:
  `AutoCloseable`, `Cloneable`, `Statement`, `Wrapper`

Direct Known Subclasses:
  `BasePrepareStatement`

    public class MariaDbStatement
    extends Object
    implements Statement, Cloneable

### Field Summary

Fields
`protected boolean` `canUseServerTimeout`
`protected boolean` `closed`
`protected MariaDbConnection` `connection` the Connection object.
`protected ExceptionFactory` `exceptionFactory`
`protected boolean` `executing`
`protected int` `fetchSize`
`protected ReentrantLock` `lock`
`protected long` `maxRows`
`protected Options` `options`
`protected Protocol` `protocol` the protocol used to talk to the server.
`protected int` `queryTimeout`
`protected Results` `results`
`protected int` `resultSetConcurrency`
`protected int` `resultSetScrollType`

### Fields inherited from interface java.sql.Statement

`CLOSE_ALL_RESULTS, CLOSE_CURRENT_RESULT, EXECUTE_FAILED, KEEP_CURRENT_RESULT, NO_GENERATED_KEYS, RETURN_GENERATED_KEYS, SUCCESS_NO_INFO`

### Constructor Summary

Constructors
`MariaDbStatement​(MariaDbConnection connection, int resultSetScrollType, int resultSetConcurrency, ExceptionFactory exceptionFactory)` Creates a new Statement.

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `addBatch​(String sql)` Adds the given SQL command to the current list of commands for this `Statement` object.
`void` `cancel()` Cancels this `Statement` object if both the DBMS and driver support aborting an SQL statement.
`protected void` `checkClose()` Check if statement is closed, and throw exception if so.
`void` `checkCloseOnCompletion​(ResultSet resultSet)` Check that close on completion is asked, and close if so.
`void` `clearBatch()` Empties this `Statement` object's current list of SQL send.
`void` `clearWarnings()` Clears all the warnings reported on this `Statement` object.
`MariaDbStatement` `clone​(MariaDbConnection connection)` Clone statement.
`void` `close()` Releases this `Statement` object's database and JDBC resources immediately instead of waiting for this to happen when it is automatically closed.
`void` `closeOnCompletion()`
`String` `enquoteIdentifier​(String identifier, boolean alwaysQuote)` Escaped identifier according to MariaDB requirement.
`String` `enquoteLiteral​(String val)` Enquote String value.
`String` `enquoteNCharLiteral​(String val)` Enquote utf8 value.
`boolean` `execute​(String sql)` executes a query.
`boolean` `execute​(String sql, int autoGeneratedKeys)` Executes the given SQL statement, which may return multiple results, and signals the driver that any auto-generated keys should be made available for retrieval.
`boolean` `execute​(String sql, int[] columnIndexes)` Executes the given SQL statement, which may return multiple results, and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval.
`boolean` `execute​(String sql, String[] columnNames)` Executes the given SQL statement, which may return multiple results, and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval.
`int[]` `executeBatch()` Execute statements.
`protected void` `executeBatchEpilogue()`
`protected BatchUpdateException` `executeBatchExceptionEpilogue​(SQLException initialSqle, int size)`
`protected void` `executeEpilogue()`
`protected SQLException` `executeExceptionEpilogue​(SQLException sqle)` Reset timeout after query, re-throw SQL exception.
`long[]` `executeLargeBatch()` Execute batch, like executeBatch(), with returning results with long[].
`long` `executeLargeUpdate​(String sql)` Executes the given SQL statement, which may be an INSERT, UPDATE, or DELETE statement or an SQL statement that returns nothing, such as an SQL DDL statement.
`long` `executeLargeUpdate​(String sql, int autoGeneratedKeys)` Identical to executeLargeUpdate(String sql), with a flag that indicate that autoGeneratedKeys (primary key fields with "auto_increment") generated id's must be retrieved.
`long` `executeLargeUpdate​(String sql, int[] columnIndexes)` Identical to executeLargeUpdate(String sql, int autoGeneratedKeys) with autoGeneratedKeys = Statement.RETURN_GENERATED_KEYS set.
`long` `executeLargeUpdate​(String sql, String[] columnNames)` Identical to executeLargeUpdate(String sql, int autoGeneratedKeys) with autoGeneratedKeys = Statement.RETURN_GENERATED_KEYS set.
`ResultSet` `executeQuery​(String sql)` executes a select query.
`protected void` `executeQueryPrologue​(boolean isBatch)` Command prolog.
`int` `executeUpdate​(String sql)` Executes an update.
`int` `executeUpdate​(String sql, int autoGeneratedKeys)` Executes the given SQL statement and signals the driver with the given flag about whether the auto-generated keys produced by this `Statement` object should be made available for retrieval.
`int` `executeUpdate​(String sql, int[] columnIndexes)` Executes the given SQL statement and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval.
`int` `executeUpdate​(String sql, String[] columnNames)` Executes the given SQL statement and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval.
`MariaDbConnection` `getConnection()` Gets the connection that created this statement.
`int` `getFetchDirection()` Retrieves the direction for fetching rows from database tables that is the default for result sets generated from this `Statement` object.
`int` `getFetchSize()` Retrieves the number of result set rows that is the default fetch size for `ResultSet` objects generated from this `Statement` object.
`ResultSet` `getGeneratedKeys()` Retrieves any auto-generated keys created as a result of executing this `Statement` object.
`long` `getLargeMaxRows()` Retrieves the maximum number of rows that a ResultSet object produced by this Statement object can contain.
`long` `getLargeUpdateCount()` Retrieves the current result as an update count; if the result is a ResultSet object or there are no more results, -1 is returned.
`int` `getMaxFieldSize()` Retrieves the maximum number of bytes that can be returned for character and binary column values in a `ResultSet` object produced by this `Statement` object.
`int` `getMaxRows()` Retrieves the maximum number of rows that a `ResultSet` object produced by this `Statement` object can contain.
`boolean` `getMoreResults()` Moves to this `Statement` object's next result, returns `true` if it is a `ResultSet` object, and implicitly closes any current `ResultSet` object(s) obtained with the method `getResultSet`.
`boolean` `getMoreResults​(int current)` Moves to this `Statement` object's next result, deals with any current `ResultSet` object(s) according to the instructions specified by the given flag, and returns `true` if the next result is a `ResultSet` object.
`int` `getQueryTimeout()` Retrieves the number of seconds the driver will wait for a `Statement` object to execute.
`ResultSet` `getResultSet()` Retrieves the current result as a ResultSet object.
`int` `getResultSetConcurrency()` Retrieves the result set concurrency for `ResultSet` objects generated by this `Statement` object.
`int` `getResultSetHoldability()` Retrieves the result set holdability for `ResultSet` objects generated by this `Statement` object.
`int` `getResultSetType()` Retrieves the result set type for `ResultSet` objects generated by this `Statement` object.
`int` `getUpdateCount()` Retrieves the current result as an update count; if the result is a ResultSet object or there are no more results, -1 is returned.
`SQLWarning` `getWarnings()` Retrieves the first warning reported by calls on this `Statement` object.
`boolean` `isClosed()` Retrieves whether this `Statement` object has been closed.
`boolean` `isCloseOnCompletion()`
`boolean` `isPoolable()` Returns a value indicating whether the `Statement` is poolable or not.
`boolean` `isSimpleIdentifier​(String identifier)` Retrieves whether identifier is a simple SQL identifier.
`boolean` `isWrapperFor​(Class<?> interfaceOrWrapper)` Returns true if this either implements the interface argument or is directly or indirectly a wrapper for an object that does.
`void` `setCursorName​(String name)` Sets the SQL cursor name to the given `String`, which will be used by subsequent `Statement` object `execute` methods.
`void` `setEscapeProcessing​(boolean enable)` Sets escape processing on or off.
`void` `setFetchDirection​(int direction)` Gives the driver a hint as to the direction in which rows will be processed in `ResultSet` objects created using this `Statement` object.
`void` `setFetchSize​(int rows)` Gives the JDBC driver a hint as to the number of rows that should be fetched from the database when more rows are needed for `ResultSet` objects generated by this `Statement` .
`void` `setLargeMaxRows​(long max)` Sets the limit for the maximum number of rows that any ResultSet object generated by this Statement object can contain to the given number.
`void` `setLocalInfileInputStream​(InputStream inputStream)` Sets the inputStream that will be used for the next execute that uses "LOAD DATA LOCAL INFILE".
`void` `setMaxFieldSize​(int max)` Sets the limit for the maximum number of bytes that can be returned for character and binary column values in a `ResultSet` object produced by this `Statement` object.
`void` `setMaxRows​(int max)` Sets the limit for the maximum number of rows that any `ResultSet` object generated by this `Statement` object can contain to the given number.
`void` `setPoolable​(boolean poolable)` Requests that a `Statement` be pooled or not pooled.
`void` `setQueryTimeout​(int seconds)` Sets the number of seconds the driver will wait for a `Statement` object to execute to the given number of seconds.
`protected void` `setTimerTask​(boolean isBatch)`
`protected void` `skipMoreResults​(Protocol protocol)`
`boolean` `testExecute​(String sql, Charset charset)` ! This method is for test only ! This permit sending query using specific charset.
`<T> T` `unwrap​(Class<T> iface)` Returns an object that implements the given interface to allow access to non-standard methods, or standard methods not exposed by the proxy.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### lock

    protected final ReentrantLock lock

#### resultSetScrollType

    protected final int resultSetScrollType

#### resultSetConcurrency

    protected final int resultSetConcurrency

#### options

    protected final Options options

#### canUseServerTimeout

    protected final boolean canUseServerTimeout

#### protocol

    protected Protocol protocol

the protocol used to talk to the server.

#### connection

    protected MariaDbConnection connection

the Connection object.

#### closed

    protected volatile boolean closed

#### queryTimeout

    protected int queryTimeout

#### maxRows

    protected long maxRows

#### results

    protected Results results

#### fetchSize

    protected int fetchSize

#### executing

    protected volatile boolean executing

#### exceptionFactory

    protected ExceptionFactory exceptionFactory

### Constructor Detail

#### MariaDbStatement

    public MariaDbStatement​(MariaDbConnection connection,
                            int resultSetScrollType,
                            int resultSetConcurrency,
                            ExceptionFactory exceptionFactory)

Creates a new Statement.

Parameters:
  `connection` - the connection to return in getConnection.
  `resultSetScrollType` - one of the following `ResultSet` constants: `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`
  `resultSetConcurrency` - a concurrency type; one of `ResultSet.CONCUR_READ_ONLY` or `ResultSet.CONCUR_UPDATABLE`
  `exceptionFactory` - exception factory

### Method Detail

#### clone

    public MariaDbStatement clone​(MariaDbConnection connection)
                           throws CloneNotSupportedException

Clone statement.

Parameters:
  `connection` - connection
Returns:
  Clone statement.
Throws:
  `CloneNotSupportedException` - if any error occur.

#### setTimerTask

    protected void setTimerTask​(boolean isBatch)

#### executeQueryPrologue

    protected void executeQueryPrologue​(boolean isBatch)
                                 throws SQLException

Command prolog.

1. clear previous query state
2. launch timeout timer if needed

Parameters:
  `isBatch` - is batch
Throws:
  `SQLException` - if statement is closed

#### executeExceptionEpilogue

    protected SQLException executeExceptionEpilogue​(SQLException sqle)

Reset timeout after query, re-throw SQL exception.

Parameters:
  `sqle` - current exception
Returns:
  SQLException exception with new message in case of timer timeout.

#### executeEpilogue

    protected void executeEpilogue()

#### executeBatchEpilogue

    protected void executeBatchEpilogue()

#### executeBatchExceptionEpilogue

    protected BatchUpdateException executeBatchExceptionEpilogue​(SQLException initialSqle,
                                                                 int size)

#### enquoteLiteral

    public String enquoteLiteral​(String val)
                          throws SQLException

Enquote String value.

Specified by:
  `enquoteLiteral` in interface `Statement`
Parameters:
  `val` - string value to enquote
Returns:
  enquoted string value
Throws:
  `SQLException` - -not possible-

#### enquoteIdentifier

    public String enquoteIdentifier​(String identifier,
                                    boolean alwaysQuote)
                             throws SQLException

Escaped identifier according to MariaDB requirement.

Specified by:
  `enquoteIdentifier` in interface `Statement`
Parameters:
  `identifier` - identifier
  `alwaysQuote` - indicate if identifier must be enquoted even if not necessary.
Returns:
  return escaped identifier, quoted when necessary or indicated with alwaysQuote.
Throws:
  `SQLException` - if containing u0000 character
See Also:
  mariadb identifier name

#### isSimpleIdentifier

    public boolean isSimpleIdentifier​(String identifier)
                               throws SQLException

Retrieves whether identifier is a simple SQL identifier. The first character is an alphabetic character from a through z, or from A through Z The string only contains alphanumeric characters or the characters "_" and "$"

Specified by:
  `isSimpleIdentifier` in interface `Statement`
Parameters:
  `identifier` - identifier
Returns:
  true if identifier doesn't have to be quoted
Throws:
  `SQLException` - exception
See Also:
  mariadb identifier name

#### enquoteNCharLiteral

    public String enquoteNCharLiteral​(String val)
                               throws SQLException

Enquote utf8 value.

Specified by:
  `enquoteNCharLiteral` in interface `Statement`
Parameters:
  `val` - value to enquote
Returns:
  enquoted String value
Throws:
  `SQLException` - - not possible -

#### testExecute

    public boolean testExecute​(String sql,
                               Charset charset)
                        throws SQLException

! This method is for test only ! This permit sending query using specific charset.

Parameters:
  `sql` - sql
  `charset` - charset
Returns:
  boolean if execution went well
Throws:
  `SQLException` - if any exception occur

#### execute

    public boolean execute​(String sql)
                    throws SQLException

executes a query.

Specified by:
  `execute` in interface `Statement`
Parameters:
  `sql` - the query
Returns:
  true if there was a result set, false otherwise.
Throws:
  `SQLException` - if the query could not be sent to server

#### execute

    public boolean execute​(String sql,
                           int autoGeneratedKeys)
                    throws SQLException

Executes the given SQL statement, which may return multiple results, and signals the driver that any auto-generated keys should be made available for retrieval. The driver will ignore this signal if the SQL statement is not an `INSERT` statement, or an SQL statement able to return auto-generated keys (the list of such statements is vendor-specific).

In some (uncommon) situations, a single SQL statement may return multiple result sets and/or update counts. Normally you can ignore this unless you are (1) executing a stored procedure that you know may return multiple results or (2) you are dynamically executing an unknown SQL string. The `execute` method executes an SQL statement and indicates the form of the first result. You must then use the methods `getResultSet` or `getUpdateCount` to retrieve the result, and `getInternalMoreResults` to move to any subsequent result(s).

Specified by:
  `execute` in interface `Statement`
Parameters:
  `sql` - any SQL statement
  `autoGeneratedKeys` - a constant indicating whether auto-generated keys should be made available for retrieval using the method`getGeneratedKeys`; one of the following constants: `Statement.RETURN_GENERATED_KEYS` or `Statement.NO_GENERATED_KEYS`
Returns:
  `true` if the first result is a `ResultSet` object; `false` if it is an update count or there are no results
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the second parameter supplied to this method is not `Statement.RETURN_GENERATED_KEYS` or `Statement.NO_GENERATED_KEYS`.
See Also:
  `getResultSet()`, `getUpdateCount()`, `getMoreResults()`, `getGeneratedKeys()`

#### execute

    public boolean execute​(String sql,
                           int[] columnIndexes)
                    throws SQLException

Executes the given SQL statement, which may return multiple results, and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval. This array contains the indexes of the columns in the target table that contain the auto-generated keys that should be made available. The driver will ignore the array if the SQL statement is not an `INSERT` statement, or an SQL statement able to return auto-generated keys (the list of such statements is vendor-specific).

Under some (uncommon) situations, a single SQL statement may return multiple result sets and/or update counts. Normally you can ignore this unless you are (1) executing a stored procedure that you know may return multiple results or (2) you are dynamically executing an unknown SQL string. The `execute` method executes an SQL statement and indicates the form of the first result. You must then use the methods `getResultSet` or `getUpdateCount` to retrieve the result, and `getInternalMoreResults` to move to any subsequent result(s).

Specified by:
  `execute` in interface `Statement`
Parameters:
  `sql` - any SQL statement
  `columnIndexes` - an array of the indexes of the columns in the inserted row that should be made available for retrieval by a call to the method `getGeneratedKeys`
Returns:
  `true` if the first result is a `ResultSet` object; `false` if it is an update count or there are no results
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the elements in the `int` array passed to this method are not valid column indexes
See Also:
  `getResultSet()`, `getUpdateCount()`, `getMoreResults()`

#### execute

    public boolean execute​(String sql,
                           String[] columnNames)
                    throws SQLException

Executes the given SQL statement, which may return multiple results, and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval. This array contains the names of the columns in the target table that contain the auto-generated keys that should be made available. The driver will ignore the array if the SQL statement is not an `INSERT` statement, or an SQL statement able to return auto-generated keys (the list of such statements is vendor-specific).

In some (uncommon) situations, a single SQL statement may return multiple result sets and/or update counts. Normally you can ignore this unless you are (1) executing a stored procedure that you know may return multiple results or (2) you are dynamically executing an unknown SQL string.

The `execute` method executes an SQL statement and indicates the form of the first result. You must then use the methods `getResultSet` or `getUpdateCount` to retrieve the result, and `getInternalMoreResults` to move to any subsequent result(s).

Specified by:
  `execute` in interface `Statement`
Parameters:
  `sql` - any SQL statement
  `columnNames` - an array of the names of the columns in the inserted row that should be made available for retrieval by a call to the method `getGeneratedKeys`
Returns:
  `true` if the next result is a `ResultSet` object; `false` if it is an update count or there are no more results
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the elements of the `String` array passed to this method are not valid column names
See Also:
  `getResultSet()`, `getUpdateCount()`, `getMoreResults()`, `getGeneratedKeys()`

#### executeQuery

    public ResultSet executeQuery​(String sql)
                           throws SQLException

executes a select query.

Specified by:
  `executeQuery` in interface `Statement`
Parameters:
  `sql` - the query to send to the server
Returns:
  a result set
Throws:
  `SQLException` - if something went wrong

#### executeUpdate

    public int executeUpdate​(String sql)
                      throws SQLException

Executes an update. Result-set are permitted for historical reason, even if spec indicate to throw exception.

Specified by:
  `executeUpdate` in interface `Statement`
Parameters:
  `sql` - the update query.
Returns:
  update count
Throws:
  `SQLException` - if the query could not be sent to server.

#### executeUpdate

    public int executeUpdate​(String sql,
                             int autoGeneratedKeys)
                      throws SQLException

Executes the given SQL statement and signals the driver with the given flag about whether the auto-generated keys produced by this `Statement` object should be made available for retrieval. The driver will ignore the flag if the SQL statement is not an `INSERT` statement, or an SQL statement able to return auto-generated keys (the list of such statements is vendor-specific). Result-set are permitted for historical reason, even if spec indicate to throw exception.

Specified by:
  `executeUpdate` in interface `Statement`
Parameters:
  `sql` - an SQL Data Manipulation Language (DML) statement, such as `INSERT`, `UPDATE` or `DELETE`; or an SQL statement that returns nothing, such as a DDL statement.
  `autoGeneratedKeys` - a flag indicating whether auto-generated keys should be made available for retrieval; one of the following constants: `Statement.RETURN_GENERATED_KEYS` `Statement.NO_GENERATED_KEYS`
Returns:
  either (1) the row count for SQL Data Manipulation Language (DML) statements or (2) 0 for SQL statements that return nothing
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the given constant is not one of those allowed

#### executeUpdate

    public int executeUpdate​(String sql,
                             int[] columnIndexes)
                      throws SQLException

Executes the given SQL statement and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval. This array contains the indexes of the columns in the target table that contain the auto-generated keys that should be made available. The driver will ignore the array if the SQL statement is not an `INSERT` statement, or an SQL statement able to return auto-generated keys (the list of such statements is vendor-specific). Result-set are permitted for historical reason, even if spec indicate to throw exception.

Specified by:
  `executeUpdate` in interface `Statement`
Parameters:
  `sql` - an SQL Data Manipulation Language (DML) statement, such as `INSERT`, `UPDATE` or `DELETE`; or an SQL statement that returns nothing, such as a DDL statement.
  `columnIndexes` - an array of column indexes indicating the columns that should be returned from the inserted row
Returns:
  either (1) the row count for SQL Data Manipulation Language (DML) statements or (2) 0 for SQL statements that return nothing
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the second argument supplied to this method is not an `int` array whose elements are valid column indexes

#### executeUpdate

    public int executeUpdate​(String sql,
                             String[] columnNames)
                      throws SQLException

Executes the given SQL statement and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval. This array contains the names of the columns in the target table that contain the auto-generated keys that should be made available. The driver will ignore the array if the SQL statement is not an `INSERT` statement, or an SQL statement able to return auto-generated keys (the list of such statements is vendor-specific). Result-set are permitted for historical reason, even if spec indicate to throw exception.

Specified by:
  `executeUpdate` in interface `Statement`
Parameters:
  `sql` - an SQL Data Manipulation Language (DML) statement, such as `INSERT`, `UPDATE` or `DELETE`; or an SQL statement that returns nothing, such as a DDL statement.
  `columnNames` - an array of the names of the columns that should be returned from the inserted row
Returns:
  either the row count for `INSERT`, `UPDATE`, or `DELETE` statements, or 0 for SQL statements that return nothing
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the second argument supplied to this method is not a `String` array whose elements are valid column names

#### executeLargeUpdate

    public long executeLargeUpdate​(String sql)
                            throws SQLException

Executes the given SQL statement, which may be an INSERT, UPDATE, or DELETE statement or an SQL statement that returns nothing, such as an SQL DDL statement. This method should be used when the returned row count may exceed Integer.MAX_VALUE.

Specified by:
  `executeLargeUpdate` in interface `Statement`
Parameters:
  `sql` - sql command
Returns:
  update counts
Throws:
  `SQLException` - if any error occur during execution

#### executeLargeUpdate

    public long executeLargeUpdate​(String sql,
                                   int autoGeneratedKeys)
                            throws SQLException

Identical to executeLargeUpdate(String sql), with a flag that indicate that autoGeneratedKeys (primary key fields with "auto_increment") generated id's must be retrieved.

Those id's will be available using getGeneratedKeys() method.

Specified by:
  `executeLargeUpdate` in interface `Statement`
Parameters:
  `sql` - sql command
  `autoGeneratedKeys` - a flag indicating whether auto-generated keys should be made available for retrieval; one of the following constants: Statement.RETURN_GENERATED_KEYS Statement.NO_GENERATED_KEYS
Returns:
  update counts
Throws:
  `SQLException` - if any error occur during execution

#### executeLargeUpdate

    public long executeLargeUpdate​(String sql,
                                   int[] columnIndexes)
                            throws SQLException

Identical to executeLargeUpdate(String sql, int autoGeneratedKeys) with autoGeneratedKeys = Statement.RETURN_GENERATED_KEYS set.

Specified by:
  `executeLargeUpdate` in interface `Statement`
Parameters:
  `sql` - sql command
  `columnIndexes` - column Indexes
Returns:
  update counts
Throws:
  `SQLException` - if any error occur during execution

#### executeLargeUpdate

    public long executeLargeUpdate​(String sql,
                                   String[] columnNames)
                            throws SQLException

Identical to executeLargeUpdate(String sql, int autoGeneratedKeys) with autoGeneratedKeys = Statement.RETURN_GENERATED_KEYS set.

Specified by:
  `executeLargeUpdate` in interface `Statement`
Parameters:
  `sql` - sql command
  `columnNames` - columns names
Returns:
  update counts
Throws:
  `SQLException` - if any error occur during execution

#### close

    public void close()
               throws SQLException

Releases this `Statement` object's database and JDBC resources immediately instead of waiting for this to happen when it is automatically closed. It is generally good practice to release resources as soon as you are finished with them to avoid tying up database resources. Calling the method `close` on a `Statement` object that is already closed has no effect. Note:When a `Statement` object is closed, its current `ResultSet` object, if one exists, is also closed.

Specified by:
  `close` in interface `AutoCloseable`
Specified by:
  `close` in interface `Statement`
Throws:
  `SQLException` - if a database access error occurs

#### getMaxFieldSize

    public int getMaxFieldSize()

Retrieves the maximum number of bytes that can be returned for character and binary column values in a `ResultSet` object produced by this `Statement` object. This limit applies only to `BINARY`, `VARBINARY`, `LONGVARBINARY`, `CHAR`, `VARCHAR`, `NCHAR`, `NVARCHAR`, `LONGNVARCHAR` and `LONGVARCHAR` columns. If the limit is exceeded, the excess data is silently discarded.

Specified by:
  `getMaxFieldSize` in interface `Statement`
Returns:
  the current column size limit for columns storing character and binary values; zero means there is no limit
See Also:
  `setMaxFieldSize(int)`

#### setMaxFieldSize

    public void setMaxFieldSize​(int max)

Sets the limit for the maximum number of bytes that can be returned for character and binary column values in a `ResultSet` object produced by this `Statement` object. This limit applies only to `BINARY`, `VARBINARY`, `LONGVARBINARY`, `CHAR`, `VARCHAR`, `NCHAR`, `NVARCHAR`, `LONGNVARCHAR` and `LONGVARCHAR` fields. If the limit is exceeded, the excess data is silently discarded. For maximum portability, use values greater than 256.

Specified by:
  `setMaxFieldSize` in interface `Statement`
Parameters:
  `max` - the new column size limit in bytes; zero means there is no limit
See Also:
  `getMaxFieldSize()`

#### getMaxRows

    public int getMaxRows()

Retrieves the maximum number of rows that a `ResultSet` object produced by this `Statement` object can contain. If this limit is exceeded, the excess rows are silently dropped.

Specified by:
  `getMaxRows` in interface `Statement`
Returns:
  the current maximum number of rows for a `ResultSet` object produced by this `Statement` object; zero means there is no limit
See Also:
  `setMaxRows(int)`

#### setMaxRows

    public void setMaxRows​(int max)
                    throws SQLException

Sets the limit for the maximum number of rows that any `ResultSet` object generated by this `Statement` object can contain to the given number. If the limit is exceeded, the excess rows are silently dropped.

Specified by:
  `setMaxRows` in interface `Statement`
Parameters:
  `max` - the new max rows limit; zero means there is no limit
Throws:
  `SQLException` - if the condition max >= 0 is not satisfied
See Also:
  `getMaxRows()`

#### getLargeMaxRows

    public long getLargeMaxRows()

Retrieves the maximum number of rows that a ResultSet object produced by this Statement object can contain. If this limit is exceeded, the excess rows are silently dropped.

Specified by:
  `getLargeMaxRows` in interface `Statement`
Returns:
  the current maximum number of rows for a ResultSet object produced by this Statement object; zero means there is no limit

#### setLargeMaxRows

    public void setLargeMaxRows​(long max)
                         throws SQLException

Sets the limit for the maximum number of rows that any ResultSet object generated by this Statement object can contain to the given number. If the limit is exceeded, the excess rows are silently dropped.

Specified by:
  `setLargeMaxRows` in interface `Statement`
Parameters:
  `max` - the new max rows limit; zero means there is no limit
Throws:
  `SQLException` - if the condition max >= 0 is not satisfied

#### setEscapeProcessing

    public void setEscapeProcessing​(boolean enable)

Sets escape processing on or off. If escape scanning is on (the default), the driver will do escape substitution before sending the SQL statement to the database. Note: Since prepared statements have usually been parsed prior to making this call, disabling escape processing for `PreparedStatements` objects will have no effect.

Specified by:
  `setEscapeProcessing` in interface `Statement`
Parameters:
  `enable` - `true` to enable escape processing; `false` to disable it

#### getQueryTimeout

    public int getQueryTimeout()

Retrieves the number of seconds the driver will wait for a `Statement` object to execute. If the limit is exceeded, a `SQLException` is thrown.

Specified by:
  `getQueryTimeout` in interface `Statement`
Returns:
  the current query timeout limit in seconds; zero means there is no limit
See Also:
  `setQueryTimeout(int)`

#### setQueryTimeout

    public void setQueryTimeout​(int seconds)
                         throws SQLException

Sets the number of seconds the driver will wait for a `Statement` object to execute to the given number of seconds. If the limit is exceeded, an `SQLException` is thrown. A JDBC driver must apply this limit to the `execute`, `executeQuery` and `executeUpdate` methods.

Specified by:
  `setQueryTimeout` in interface `Statement`
Parameters:
  `seconds` - the new query timeout limit in seconds; zero means there is no limit
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the condition seconds >= 0 is not satisfied
See Also:
  `getQueryTimeout()`

#### setLocalInfileInputStream

    public void setLocalInfileInputStream​(InputStream inputStream)
                                   throws SQLException

Sets the inputStream that will be used for the next execute that uses "LOAD DATA LOCAL INFILE". The name specified as local file/URL will be ignored.

Parameters:
  `inputStream` - inputStream instance, that will be used to send data to server
Throws:
  `SQLException` - if statement is closed

#### cancel

    public void cancel()
                throws SQLException

Cancels this `Statement` object if both the DBMS and driver support aborting an SQL statement. This method can be used by one thread to cancel a statement that is being executed by another thread.

In case there is result-set from this Statement that are still streaming data from server, will cancel streaming.

Specified by:
  `cancel` in interface `Statement`
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed `Statement`

#### getWarnings

    public SQLWarning getWarnings()
                           throws SQLException

Retrieves the first warning reported by calls on this `Statement` object. Subsequent `Statement` object warnings will be chained to this `SQLWarning` object.

The warning chain is automatically cleared each time a statement is (re)executed. This method may not be called on a closed `Statement` object; doing so will cause an `SQLException` to be thrown.

Note: If you are processing a `ResultSet` object, any warnings associated with reads on that `ResultSet` object will be chained on it rather than on the `Statement` object that produced it.

Specified by:
  `getWarnings` in interface `Statement`
Returns:
  the first `SQLWarning` object or `null` if there are no warnings
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed `Statement`

#### clearWarnings

    public void clearWarnings()

Clears all the warnings reported on this `Statement` object. After a call to this method, the method `getWarnings` will return `null` until a new warning is reported for this `Statement` object.

Specified by:
  `clearWarnings` in interface `Statement`

#### setCursorName

    public void setCursorName​(String name)
                       throws SQLException

Sets the SQL cursor name to the given `String`, which will be used by subsequent `Statement` object `execute` methods. This name can then be used in SQL positioned update or delete statements to identify the current row in the `ResultSet` object generated by this statement. If the database does not support positioned update/delete, this method is a noop. To insure that a cursor has the proper isolation level to support updates, the cursor's `SELECT` statement should have the form `SELECT FOR UPDATE`. If `FOR UPDATE` is not present, positioned updates may fail.

Note: By definition, the execution of positioned updates and deletes must be done by a different `Statement` object than the one that generated the `ResultSet` object being used for positioning. Also, cursor names must be unique within a connection.

Specified by:
  `setCursorName` in interface `Statement`
Parameters:
  `name` - the new cursor name, which must be unique within a connection
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed `Statement`

#### getConnection

    public MariaDbConnection getConnection()

Gets the connection that created this statement.

Specified by:
  `getConnection` in interface `Statement`
Returns:
  the connection

#### getGeneratedKeys

    public ResultSet getGeneratedKeys()
                               throws SQLException

Retrieves any auto-generated keys created as a result of executing this `Statement` object. If this `Statement` object did not generate any keys, an empty `ResultSet` object is returned.

Note:If the columns which represent the auto-generated keys were not specified, the JDBC driver implementation will determine the columns which best represent the auto-generated keys.

Specified by:
  `getGeneratedKeys` in interface `Statement`
Returns:
  a `ResultSet` object containing the auto-generated key(s) generated by the execution of this `Statement` object
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed `Statement`

#### getResultSetHoldability

    public int getResultSetHoldability()

Retrieves the result set holdability for `ResultSet` objects generated by this `Statement` object.

Specified by:
  `getResultSetHoldability` in interface `Statement`
Returns:
  either `ResultSet.HOLD_CURSORS_OVER_COMMIT` or `ResultSet.CLOSE_CURSORS_AT_COMMIT`
Since:
  1.4

#### isClosed

    public boolean isClosed()

Retrieves whether this `Statement` object has been closed. A `Statement` is closed if the method close has been called on it, or if it is automatically closed.

Specified by:
  `isClosed` in interface `Statement`
Returns:
  true if this `Statement` object is closed; false if it is still open
Since:
  1.6

#### isPoolable

    public boolean isPoolable()

Returns a value indicating whether the `Statement` is poolable or not.

Specified by:
  `isPoolable` in interface `Statement`
Returns:
  `true` if the `Statement` is poolable; `false` otherwise
Since:
  1.6
See Also:
  `setPoolable(boolean)`

#### setPoolable

    public void setPoolable​(boolean poolable)

Requests that a `Statement` be pooled or not pooled. The value specified is a hint to the statement pool implementation indicating whether the application wants the statement to be pooled. It is up to the statement pool manager as to whether the hint is used.

The poolable value of a statement is applicable to both internal statement caches implemented by the driver and external statement caches implemented by application servers and other applications.

By default, a `Statement` is not poolable when created, and a `PreparedStatement` and `CallableStatement` are poolable when created.

Specified by:
  `setPoolable` in interface `Statement`
Parameters:
  `poolable` - requests that the statement be pooled if true and that the statement not be pooled if false
Since:
  1.6

#### getResultSet

    public ResultSet getResultSet()
                           throws SQLException

Retrieves the current result as a ResultSet object. This method should be called only once per result.

Specified by:
  `getResultSet` in interface `Statement`
Returns:
  the current result as a ResultSet object or null if the result is an update count or there are no more results
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed Statement

#### getUpdateCount

    public int getUpdateCount()

Retrieves the current result as an update count; if the result is a ResultSet object or there are no more results, -1 is returned. This method should be called only once per result.

Specified by:
  `getUpdateCount` in interface `Statement`
Returns:
  the current result as an update count; -1 if the current result is a ResultSet object or there are no more results

#### getLargeUpdateCount

    public long getLargeUpdateCount()

Retrieves the current result as an update count; if the result is a ResultSet object or there are no more results, -1 is returned.

Specified by:
  `getLargeUpdateCount` in interface `Statement`
Returns:
  last update count

#### skipMoreResults

    protected void skipMoreResults​(Protocol protocol)
                            throws SQLException

Throws:
  `SQLException`

#### getMoreResults

    public boolean getMoreResults()
                           throws SQLException

Moves to this `Statement` object's next result, returns `true` if it is a `ResultSet` object, and implicitly closes any current `ResultSet` object(s) obtained with the method `getResultSet`. There are no more results when the following is true:

     // stmt is a Statement object
     ((stmt.getInternalMoreResults() == false) && (stmt.getUpdateCount() == -1))

Specified by:
  `getMoreResults` in interface `Statement`
Returns:
  `true` if the next result is a `ResultSet` object; `false` if it is an update count or there are no more results
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed `Statement`
See Also:
  `execute(java.lang.String)`

#### getMoreResults

    public boolean getMoreResults​(int current)
                           throws SQLException

Moves to this `Statement` object's next result, deals with any current `ResultSet` object(s) according to the instructions specified by the given flag, and returns `true` if the next result is a `ResultSet` object. There are no more results when the following is true:

     // stmt is a Statement object
     ((stmt.getInternalMoreResults(current) == false) && (stmt.getUpdateCount() == -1))

Specified by:
  `getMoreResults` in interface `Statement`
Parameters:
  `current` - one of the following `Statement` constants indicating what should happen to current `ResultSet` objects obtained using the method `getResultSet`: `Statement.CLOSE_CURRENT_RESULT`, `Statement.KEEP_CURRENT_RESULT`, or `Statement.CLOSE_ALL_RESULTS`
Returns:
  `true` if the next result is a `ResultSet` object; `false` if it is an update count or there are no more results
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the argument supplied is not one of the following: `Statement.CLOSE_CURRENT_RESULT`, `Statement.KEEP_CURRENT_RESULT` or `Statement.CLOSE_ALL_RESULTS`
See Also:
  `execute(java.lang.String)`

#### getFetchDirection

    public int getFetchDirection()

Retrieves the direction for fetching rows from database tables that is the default for result sets generated from this `Statement` object. If this `Statement` object has not set a fetch direction by calling the method `setFetchDirection`, the return value is implementation-specific.

Specified by:
  `getFetchDirection` in interface `Statement`
Returns:
  the default fetch direction for result sets generated from this `Statement` object
Since:
  1.2
See Also:
  `setFetchDirection(int)`

#### setFetchDirection

    public void setFetchDirection​(int direction)

Gives the driver a hint as to the direction in which rows will be processed in `ResultSet` objects created using this `Statement` object. The default value is `ResultSet.FETCH_FORWARD`.

Note that this method sets the default fetch direction for result sets generated by this `Statement` object. Each result set has its own methods for getting and setting its own fetch direction.

Specified by:
  `setFetchDirection` in interface `Statement`
Parameters:
  `direction` - the initial direction for processing rows
Since:
  1.2
See Also:
  `getFetchDirection()`

#### getFetchSize

    public int getFetchSize()

Retrieves the number of result set rows that is the default fetch size for `ResultSet` objects generated from this `Statement` object. If this `Statement` object has not set a fetch size by calling the method `setFetchSize`, the return value is implementation-specific.

Specified by:
  `getFetchSize` in interface `Statement`
Returns:
  the default fetch size for result sets generated from this `Statement` object
See Also:
  `setFetchSize(int)`

#### setFetchSize

    public void setFetchSize​(int rows)
                      throws SQLException

Gives the JDBC driver a hint as to the number of rows that should be fetched from the database when more rows are needed for `ResultSet` objects generated by this `Statement` . If the value specified is zero, then the hint is ignored. The default value is zero.

Specified by:
  `setFetchSize` in interface `Statement`
Parameters:
  `rows` - the number of rows to fetch
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the condition `rows >= 0` is not satisfied.
See Also:
  `getFetchSize()`

#### getResultSetConcurrency

    public int getResultSetConcurrency()

Retrieves the result set concurrency for `ResultSet` objects generated by this `Statement` object.

Specified by:
  `getResultSetConcurrency` in interface `Statement`
Returns:
  either `ResultSet.CONCUR_READ_ONLY` or `ResultSet.CONCUR_UPDATABLE`
Since:
  1.2

#### getResultSetType

    public int getResultSetType()

Retrieves the result set type for `ResultSet` objects generated by this `Statement` object.

Specified by:
  `getResultSetType` in interface `Statement`
Returns:
  one of `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`

#### addBatch

    public void addBatch​(String sql)
                  throws SQLException

Adds the given SQL command to the current list of commands for this `Statement` object. The send in this list can be executed as a batch by calling the method `executeBatch`.

Specified by:
  `addBatch` in interface `Statement`
Parameters:
  `sql` - typically this is a SQL `INSERT` or `UPDATE` statement
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the driver does not support batch updates
See Also:
  `executeBatch()`, `DatabaseMetaData.supportsBatchUpdates()`

#### clearBatch

    public void clearBatch()

Empties this `Statement` object's current list of SQL send.

Specified by:
  `clearBatch` in interface `Statement`
Since:
  1.2
See Also:
  `addBatch(java.lang.String)`, `DatabaseMetaData.supportsBatchUpdates()`

#### executeBatch

    public int[] executeBatch()
                       throws SQLException

Execute statements. depending on option, queries mays be rewritten :

those queries will be rewritten if possible to INSERT INTO ... VALUES (...) ; INSERT INTO ... VALUES (...);

if option rewriteBatchedStatements is set to true, rewritten to INSERT INTO ... VALUES (...), (...);

Specified by:
  `executeBatch` in interface `Statement`
Returns:
  an array of update counts containing one element for each command in the batch. The elements of the array are ordered according to the order in which send were added to the batch.
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the driver does not support batch statements. Throws `BatchUpdateException` (a subclass of `SQLException`) if one of the send sent to the database fails to execute properly or attempts to return a result set.
Since:
  1.3
See Also:
  `addBatch(java.lang.String)`, `DatabaseMetaData.supportsBatchUpdates()`

#### executeLargeBatch

    public long[] executeLargeBatch()
                             throws SQLException

Execute batch, like executeBatch(), with returning results with long[]. For when row count may exceed Integer.MAX_VALUE.

Specified by:
  `executeLargeBatch` in interface `Statement`
Returns:
  an array of update counts (one element for each command in the batch)
Throws:
  `SQLException` - if a database error occur.

#### unwrap

    public <T> T unwrap​(Class<T> iface)
                 throws SQLException

Returns an object that implements the given interface to allow access to non-standard methods, or standard methods not exposed by the proxy.

If the receiver implements the interface then the result is the receiver or a proxy for the receiver. If the receiver is a wrapper and the wrapped object implements the interface then the result is the wrapped object or a proxy for the wrapped object. Otherwise return the the result of calling `unwrap` recursively on the wrapped object or a proxy for that result. If the receiver is not a wrapper and does not implement the interface, then an `SQLException` is thrown.

Specified by:
  `unwrap` in interface `Wrapper`
Parameters:
  `iface` - A Class defining an interface that the result must implement.
Returns:
  an object that implements the interface. May be a proxy for the actual implementing object.
Throws:
  `SQLException` - If no object found that implements the interface
Since:
  1.6

#### isWrapperFor

    public boolean isWrapperFor​(Class<?> interfaceOrWrapper)
                         throws SQLException

Returns true if this either implements the interface argument or is directly or indirectly a wrapper for an object that does. Returns false otherwise. If this implements the interface then return true, else if this is a wrapper then return the result of recursively calling `isWrapperFor` on the wrapped object. If this does not implement the interface and is not a wrapper, return false. This method should be implemented as a low-cost operation compared to `unwrap` so that callers can use this method to avoid expensive `unwrap` calls that may fail. If this method returns true then calling `unwrap` with the same argument should succeed.

Specified by:
  `isWrapperFor` in interface `Wrapper`
Parameters:
  `interfaceOrWrapper` - a Class defining an interface.
Returns:
  true if this implements the interface or directly or indirectly wraps an object that does.
Throws:
  `SQLException` - if an error occurs while determining whether this is a wrapper for an object with the given interface.
Since:
  1.6

#### closeOnCompletion

    public void closeOnCompletion()

Specified by:
  `closeOnCompletion` in interface `Statement`

#### isCloseOnCompletion

    public boolean isCloseOnCompletion()

Specified by:
  `isCloseOnCompletion` in interface `Statement`

#### checkCloseOnCompletion

    public void checkCloseOnCompletion​(ResultSet resultSet)
                                throws SQLException

Check that close on completion is asked, and close if so.

Parameters:
  `resultSet` - resultSet
Throws:
  `SQLException` - if close has error

#### checkClose

    protected void checkClose()
                       throws SQLException

Check if statement is closed, and throw exception if so.

Throws:
  `SQLException` - if statement close